
USE SVH_REPORT_DB
GO

/*
|| Autor: Jhon Reyes
|| Fecha: 2022.05.03
|| Proyecto: JUNO
|| Proceso: Actualizar la tabla MAESTRO_CARTERA, con los valores del cierre contable. 
||				Solo se actualizaran los campos que dependen del cierre contable		
*/


--=======================================================================
--							TEMPORALES
--=======================================================================

DROP TABLE IF EXISTS #TMP_SOCIEDADES

SELECT CAMPO, 
		 VALOR AS SOCIEDAD
  INTO #TMP_SOCIEDADES
  FROM [JUNO].[TMP_PARAMETRICA]
WHERE INFORME = 'SOCIEDAD'
  AND CONCEPTO = 'KUTXABANK. PERIMETRO INMOBILIARIA'
  AND FLAG = 1
  

--=========================================================================================================================================
--														         UPDATE OTROS CAMPOS CIERRE CONTABLE - MAESTRO_CARTERA
--=========================================================================================================================================


	DECLARE @FECHA_CIERRE_CONTABLE VARCHAR(10); 
	SET @FECHA_CIERRE_CONTABLE = CONVERT(VARCHAR(10),DATEADD(DD,-(DAY(GETDATE())),GETDATE()),121);
	
	DECLARE @ANYOMES VARCHAR(6);
	DECLARE @PERIODO_ANT INT;
	SET @ANYOMES = CONVERT(VARCHAR(6),DATEADD(dd,-(DAY(GETDATE())),GETDATE()),112);
	SET @PERIODO_ANT = (SELECT MAX(PERIODO) FROM [JUNO].[INF_ADJUDICADOS] WHERE PERIODO != @ANYOMES);


	/*
	|| UR_VALORES_CONTABLES_CONS_KB
	*/

	DROP TABLE IF EXISTS #TMP_JUNO_UR_VALORES_CONTABLES_CONS_KB
	SELECT TOP 1 WITH TIES 
		  CONS_KB.SOCIEDAD
		, CONS_KB.UNIDAD_REGISTRAL
		, CONS_KB.CONCEPTO_CONSOLIDACION
		, CONS_KB.IMPORTE
		, ROW_NUMBER() OVER(PARTITION BY CONS_KB.SOCIEDAD, CONS_KB.UNIDAD_REGISTRAL, CONS_KB.CONCEPTO_CONSOLIDACION ORDER BY CONS_KB.FECHA_INICIO_VALIDEZ DESC) RN_CONCEPTO
		INTO #TMP_JUNO_UR_VALORES_CONTABLES_CONS_KB
	FROM [SVH_CORP_DB].dbo.[UR_VALORES_CONTABLES_CONS_KB] CONS_KB
	INNER JOIN [JUNO].[TMP_UR_MAESTRO_HIST] UR ON CONS_KB.SOCIEDAD = UR.SOCIEDAD AND CONS_KB.UNIDAD_REGISTRAL = UR.UNIDAD_REGISTRAL
	WHERE UR.IND_MIGRACION = 'X'
	ORDER BY RN_CONCEPTO		


	UPDATE CARTERA
	SET CARTERA.USR062_DETERIORO_CIERRE_EJERCICIO_ANTERIOR = CIERRE.IMPORTE
	FROM [JUNO].[MAESTRO_CARTERA] CARTERA
    INNER JOIN #TMP_SOCIEDADES SOC  ON CARTERA.SOCIEDAD = SOC.SOCIEDAD
	INNER JOIN (SELECT SOCIEDAD, UNIDAD_REGISTRAL, IMPORTE FROM #TMP_JUNO_UR_VALORES_CONTABLES_CONS_KB WHERE CONCEPTO_CONSOLIDACION = '5') CIERRE 
					ON CARTERA.SOCIEDAD = CIERRE.SOCIEDAD AND CARTERA.UNIDAD_REGISTRAL = CIERRE.UNIDAD_REGISTRAL
	WHERE CARTERA.PERIODO = @ANYOMES
			
			
	UPDATE CARTERA
	SET CARTERA.USR063_CORRECCION_CONSOLIDADA_CIERRE_EJERCICIO_ANTERIOR = CIERRE.IMPORTE
	FROM [JUNO].[MAESTRO_CARTERA] CARTERA
    INNER JOIN #TMP_SOCIEDADES SOC  ON CARTERA.SOCIEDAD = SOC.SOCIEDAD
	INNER JOIN (SELECT SOCIEDAD, UNIDAD_REGISTRAL, IMPORTE FROM #TMP_JUNO_UR_VALORES_CONTABLES_CONS_KB WHERE CONCEPTO_CONSOLIDACION = '1') CIERRE 
					ON CARTERA.SOCIEDAD = CIERRE.SOCIEDAD AND CARTERA.UNIDAD_REGISTRAL = CIERRE.UNIDAD_REGISTRAL
	WHERE CARTERA.PERIODO = @ANYOMES	

	UPDATE CARTERA
	SET CARTERA.USR086_DIREFENCIA_VNC_CONSOLIDADO = CIERRE.IMPORTE
	FROM [JUNO].[MAESTRO_CARTERA] CARTERA
    INNER JOIN #TMP_SOCIEDADES SOC  ON CARTERA.SOCIEDAD = SOC.SOCIEDAD
	INNER JOIN (SELECT SOCIEDAD, UNIDAD_REGISTRAL, IMPORTE FROM #TMP_JUNO_UR_VALORES_CONTABLES_CONS_KB WHERE CONCEPTO_CONSOLIDACION = '4') CIERRE 
					ON CARTERA.SOCIEDAD = CIERRE.SOCIEDAD AND CARTERA.UNIDAD_REGISTRAL = CIERRE.UNIDAD_REGISTRAL
	WHERE CARTERA.PERIODO = @ANYOMES	
			
	UPDATE CARTERA
	SET CARTERA.USR075_OTROS_AJUSTES = CIERRE.IMPORTE
	FROM [JUNO].[MAESTRO_CARTERA] CARTERA
    INNER JOIN #TMP_SOCIEDADES SOC ON CARTERA.SOCIEDAD = SOC.SOCIEDAD
	INNER JOIN (SELECT SOCIEDAD, UNIDAD_REGISTRAL, IMPORTE FROM #TMP_JUNO_UR_VALORES_CONTABLES_CONS_KB WHERE CONCEPTO_CONSOLIDACION = '6') CIERRE 
					ON CARTERA.SOCIEDAD = CIERRE.SOCIEDAD AND CARTERA.UNIDAD_REGISTRAL = CIERRE.UNIDAD_REGISTRAL
	WHERE CARTERA.PERIODO = @ANYOMES	
            
	UPDATE CARTERA
	SET CARTERA.USR064_FONDO_MINIMO_EXIGIDO		   = CIERRE.IMPORTE
	FROM [JUNO].[MAESTRO_CARTERA] CARTERA
    INNER JOIN #TMP_SOCIEDADES SOC ON CARTERA.SOCIEDAD = SOC.SOCIEDAD
    INNER JOIN (SELECT SOCIEDAD, UNIDAD_REGISTRAL, IMPORTE FROM #TMP_JUNO_UR_VALORES_CONTABLES_CONS_KB WHERE CONCEPTO_CONSOLIDACION = '2') CIERRE
			ON CARTERA.SOCIEDAD = CIERRE.SOCIEDAD AND CARTERA.UNIDAD_REGISTRAL = CIERRE.UNIDAD_REGISTRAL
	WHERE CARTERA.PERIODO = @ANYOMES	            
            			

    UPDATE CARTERA
    SET USR065_OTROS_AJUSTES_COSTE = CIERRE.IMPORTE
    FROM [JUNO].[MAESTRO_CARTERA] CARTERA
    INNER JOIN #TMP_SOCIEDADES SOC ON CARTERA.SOCIEDAD = SOC.SOCIEDAD
    INNER JOIN (SELECT SOCIEDAD, UNIDAD_REGISTRAL, IMPORTE FROM #TMP_JUNO_UR_VALORES_CONTABLES_CONS_KB WHERE CONCEPTO_CONSOLIDACION = '3') CIERRE
			ON CARTERA.SOCIEDAD = CIERRE.SOCIEDAD AND CARTERA.UNIDAD_REGISTRAL = CIERRE.UNIDAD_REGISTRAL
	WHERE CARTERA.PERIODO = @ANYOMES
		
   UPDATE CARTERA
    SET USR095_PERDIDA_ADICIONAL_ADJUDICACION = CIERRE.IMPORTE
    FROM [JUNO].[MAESTRO_CARTERA] CARTERA
    INNER JOIN #TMP_SOCIEDADES SOC ON CARTERA.SOCIEDAD = SOC.SOCIEDAD
    INNER JOIN (SELECT SOCIEDAD, UNIDAD_REGISTRAL, IMPORTE FROM #TMP_JUNO_UR_VALORES_CONTABLES_CONS_KB WHERE CONCEPTO_CONSOLIDACION = '7') CIERRE
			ON CARTERA.SOCIEDAD = CIERRE.SOCIEDAD AND CARTERA.UNIDAD_REGISTRAL = CIERRE.UNIDAD_REGISTRAL
	WHERE CARTERA.PERIODO = @ANYOMES
      
   UPDATE CARTERA
    SET USR096_REVERSION_DETERIORO_ADJUDICACION = CIERRE.IMPORTE
    FROM [JUNO].[MAESTRO_CARTERA] CARTERA
    INNER JOIN #TMP_SOCIEDADES SOC ON CARTERA.SOCIEDAD = SOC.SOCIEDAD
    INNER JOIN (SELECT SOCIEDAD, UNIDAD_REGISTRAL, IMPORTE FROM #TMP_JUNO_UR_VALORES_CONTABLES_CONS_KB WHERE CONCEPTO_CONSOLIDACION = '8') CIERRE
			ON CARTERA.SOCIEDAD = CIERRE.SOCIEDAD AND CARTERA.UNIDAD_REGISTRAL = CIERRE.UNIDAD_REGISTRAL
	WHERE CARTERA.PERIODO = @ANYOMES

	/*
	|| Autor: Jhon Reyes
	|| Fecha: 2022.04.29
	|| Proceso: Se crea tabla temporal para obtener el mapeo de los campos Activo Adjudicado (USR002) y Cartera Contable Tenedora (USR015). 
	*/
			
	
	DECLARE @CLASIFICACION_CONTABLE_MODELO TABLE (USR055 VARCHAR(2) , USR002_ACTIVO_ADJUDICADO VARCHAR(2), USR015_CARTERA_CONTABLE_TENEEDORA VARCHAR(3))
	INSERT INTO @CLASIFICACION_CONTABLE_MODELO 
	VALUES 	
			('01', '01', 'C03'),
			('02', '02', 'C01'),
			('03', '03', 'C02'),
			('04', '04', 'C02'),
			('05', '05', 'C02'),
			('06', '06', 'C02'),
			('07', '01', 'C03'),
			('08', '06', 'C02'),
			('09', '04', 'C02'),
			('10', '07', ''),
			('11', '08', '')
            
    UPDATE CARTERA
    SET USR002_ACTIVO_ADJUDICADO = MODELO.USR002_ACTIVO_ADJUDICADO,
        USR015_CARTERA_CONTABLE_TENEEDORA = MODELO.USR015_CARTERA_CONTABLE_TENEEDORA
    FROM [JUNO].[MAESTRO_CARTERA] CARTERA
    INNER JOIN [JUNO].[TMP_UR_MAESTRO_HIST] UR ON CARTERA.SOCIEDAD = UR.SOCIEDAD AND CARTERA.UNIDAD_REGISTRAL = UR.UNIDAD_REGISTRAL
	 INNER JOIN #TMP_SOCIEDADES SOC ON CARTERA.SOCIEDAD = SOC.SOCIEDAD
    INNER JOIN @CLASIFICACION_CONTABLE_MODELO MODELO ON CARTERA.USR055_CLASIFICACION_CONTABLE_MODELO = MODELO.USR055
	WHERE CARTERA.PERIODO = @ANYOMES
	AND UR.IND_MIGRACION = 'X'
      
      
	/*
	|| UR_CARACTERISTICAS_TRASP
	*/				
		
	UPDATE CARTERA
	SET
	CARTERA.USR025_FECHA_ENTRADA_CONTABLE = CIERRE.FECHA_ENTRADA_CONTABLE	
	-- ... (aquí se irán poniendo el resto de campo que dependen del cierre contable de la tabla UR_CARACTERISTICAS_TRASP)
	FROM [JUNO].[MAESTRO_CARTERA] CARTERA
   INNER JOIN [JUNO].[TMP_UR_MAESTRO_HIST] UR ON CARTERA.SOCIEDAD = UR.SOCIEDAD AND CARTERA.UNIDAD_REGISTRAL = UR.UNIDAD_REGISTRAL
	INNER JOIN #TMP_SOCIEDADES SOC ON CARTERA.SOCIEDAD = SOC.SOCIEDAD
	INNER JOIN [SVH_CORP_DB].[dbo].[UR_CARACTERISTICAS_TRASP] CIERRE ON CARTERA.SOCIEDAD = CIERRE.SOCIEDAD AND CARTERA.UNIDAD_REGISTRAL = CIERRE.UNIDAD_REGISTRAL
	WHERE CARTERA.PERIODO = @ANYOMES
	AND UR.IND_MIGRACION = 'X'
		

	/*
	|| VENTAS_OPERATIVA
	*/

	UPDATE CARTERA
	SET CARTERA.ADJ443_PRECIO_NETO_VENTA = CIERRE.PRECIO_VENTA_FINAL
	FROM [JUNO].[MAESTRO_CARTERA] CARTERA
   INNER JOIN [JUNO].[TMP_UR_MAESTRO_HIST] UR ON CARTERA.SOCIEDAD = UR.SOCIEDAD AND CARTERA.UNIDAD_REGISTRAL = UR.UNIDAD_REGISTRAL
	INNER JOIN #TMP_SOCIEDADES SOC ON CARTERA.SOCIEDAD = SOC.SOCIEDAD
	INNER JOIN  [SVH_CORP_DB].[DBO].[VENTAS_OPERATIVA] CIERRE ON CARTERA.SOCIEDAD = CIERRE.SOCIEDAD AND CARTERA.UNIDAD_REGISTRAL = CIERRE.UNIDAD_REGISTRAL
	WHERE ISNULL(CIERRE.VENTA_ANULADA, '') = ''
	AND CIERRE.FECHA_ANULACION IS NULL
	AND CARTERA.PERIODO = @ANYOMES
	AND UR.IND_MIGRACION = 'X'

		
	/*
	|| "VENTAS_OPERATIVA" OR CONDICIONES_PRECIOS
	*/

	DROP TABLE IF EXISTS #TMP_JUNO_CONDICIONES_PRECIOS
	SELECT Z.* INTO #TMP_JUNO_CONDICIONES_PRECIOS
	FROM(
		SELECT
			 CP.SOCIEDAD
		  , CP.UNIDAD_REGISTRAL
		  , CP.IMPORTE
		  , CP.CLASE_CONDICION
		  , CP.FECHA_INI_VALIDEZ
		  , CP.FECHA_FIN_VALIDEZ
		  , CP.IND_BORRADO
		  , MAX(CP.FECHA_INI_VALIDEZ) OVER(PARTITION BY CP.SOCIEDAD, CP.UNIDAD_REGISTRAL) FECHA_INI_VALIDEZ_MAX
		FROM [SVH_CORP_DB].[dbo].[CONDICIONES_PRECIOS] CP
		INNER JOIN [JUNO].[MAESTRO_CARTERA] CARTERA 
			ON CP.SOCIEDAD = CARTERA.SOCIEDAD 
			AND CP.UNIDAD_REGISTRAL = CARTERA.UNIDAD_REGISTRAL
			AND CARTERA.PERIODO = @ANYOMES
		INNER JOIN [JUNO].[TMP_UR_MAESTRO_HIST] UR ON CARTERA.SOCIEDAD = UR.SOCIEDAD AND CARTERA.UNIDAD_REGISTRAL = UR.UNIDAD_REGISTRAL AND UR.IND_MIGRACION = 'X'
		)Z
	WHERE FECHA_INI_VALIDEZ = FECHA_INI_VALIDEZ_MAX

	DROP TABLE IF EXISTS #TMP_JUNO_CONDICIONES_PRECIOS_FINAL
	SELECT 
		 SOCIEDAD
	  , UNIDAD_REGISTRAL
	  , IMPORTE
	  INTO #TMP_JUNO_CONDICIONES_PRECIOS_FINAL 
	FROM #TMP_JUNO_CONDICIONES_PRECIOS
	WHERE YEAR(FECHA_FIN_VALIDEZ) = 9999 AND IND_BORRADO = '' AND CLASE_CONDICION IN('Z200', 'Z211')	

	UPDATE CARTERA
	SET CARTERA.USR097_PRECIO_BRUTO_VENTA = (CASE WHEN CARTERA.CONTROL_CARTERA = 'VENTA' THEN CARTERA.ADJ443_PRECIO_NETO_VENTA ELSE CIERRE.IMPORTE END)
	FROM [JUNO].[MAESTRO_CARTERA] CARTERA
    INNER JOIN #TMP_SOCIEDADES SOC ON CARTERA.SOCIEDAD = SOC.SOCIEDAD
	INNER JOIN #TMP_JUNO_CONDICIONES_PRECIOS_FINAL CIERRE ON CARTERA.SOCIEDAD = CIERRE.SOCIEDAD AND CARTERA.UNIDAD_REGISTRAL = CIERRE.UNIDAD_REGISTRAL
	WHERE CARTERA.PERIODO = @ANYOMES
	
	/*
	|| CONS18_RESULTADO_VENTA_FILIAL: (USR097_PRECIO_BRUTO_VENTA - USR044_VALOR_CONTABLE_NETO)
	*/
	
	UPDATE CARTERA
	SET CARTERA.CONS18_RESULTADO_VENTA_FILIAL = (CARTERA.USR097_PRECIO_BRUTO_VENTA - CARTERA.USR044_VALOR_CONTABLE_NETO)
	FROM [JUNO].[MAESTRO_CARTERA] CARTERA
    INNER JOIN #TMP_SOCIEDADES SOC ON CARTERA.SOCIEDAD = SOC.SOCIEDAD
	WHERE CARTERA.PERIODO = @ANYOMES	

    /*
    || ADJ315 Valor Transmisión
    */
    
    UPDATE CARTERA
    SET ADJ315_VALOR_TRANSMISION =  CAST((CASE WHEN FUSION.VALOR_TRANSMISION = '' THEN 0.0 ELSE FUSION.VALOR_TRANSMISION END) AS NUMERIC(13, 2)) 
    FROM [JUNO].[MAESTRO_CARTERA] CARTERA
    INNER JOIN [JUNO].[TMP_UR_MAESTRO_HIST] UR ON CARTERA.SOCIEDAD = UR.SOCIEDAD AND CARTERA.UNIDAD_REGISTRAL = UR.UNIDAD_REGISTRAL
	 INNER JOIN #TMP_SOCIEDADES SOC ON CARTERA.SOCIEDAD = SOC.SOCIEDAD
    INNER JOIN [SVH_CORP_DB].[DBO].[DATOS_FUSION] FUSION ON CARTERA.SOCIEDAD = FUSION.SOCIEDAD AND CARTERA.UNIDAD_REGISTRAL = FUSION.UNIDAD_REGISTRAL
	WHERE CARTERA.PERIODO = @ANYOMES
	AND UR.IND_MIGRACION = 'X'


    /*
	|| Autor: Jhon Reyes
	|| Fecha: 2022.05.31
	|| Proceso: Se crea tabla temporal para obtener el mapeo del campo Motivo Salida (USR040)
	*/

	DECLARE @MOTIVO_SALIDA TABLE (CODIGO_ACTUACION_BAJA_UR VARCHAR(4), DESC_CODIGO_ACTUACION_BAJA_UR VARCHAR(40), USR040_CODIGO VARCHAR(4), USR040_DENOMINACION VARCHAR(40))
	INSERT INTO @MOTIVO_SALIDA 
	VALUES	
			('BPAG', 'Baja por Agregación', '1', 'SEGREGACIÓN'),
			('BPSG', 'Baja por Segregación', '1', 'SEGREGACIÓN'),
			('BSGP', 'Baja por Segregación Parcial', '1', 'SEGREGACIÓN'),
			('BOTM', 'Baja por Otros Motivos', '3', 'ANULACIÓN ADJUDICACIÓN'),
			('BRTR', 'Baja por Retrocesión', '3', 'ANULACIÓN ADJUDICACIÓN'),
			('BNUA', 'Baja por Nulidad de Actuación', '3', 'ANULACIÓN ADJUDICACIÓN'),
			('BPPJ', 'Baja por Paralización Proced. Judicial', '3', 'ANULACIÓN ADJUDICACIÓN'),
			('BVTA', 'Baja por Venta', '6', 'VENTA CONTADO'),
			('BVCT', 'Baja por Venta de Cartera', '6', 'VENTA CONTADO'),			
			('BVAF', 'Baja venta antes de fusión', '6', 'VENTA CONTADO'),
			('BERA', 'Baja por Error en Alta', '7', 'AGRUPACIÓN'),
			('BCER', 'Baja por Cesíon de Remate', '7', 'AGRUPACIÓN'),
			('BVPE', 'Baja por venta por permuta', '10', 'PERMUTA'),
            ('BCGR', 'Baja por Cambio de Grupo','13', 'BAJA POR APORTACIÓN' )
            
            
    UPDATE CARTERA
    SET USR040_MOTIVO_SALIDA = MOTIVO.USR040_CODIGO
    FROM [JUNO].[MAESTRO_CARTERA] CARTERA
    INNER JOIN [JUNO].[TMP_UR_MAESTRO_HIST] UR ON CARTERA.SOCIEDAD = UR.SOCIEDAD AND CARTERA.UNIDAD_REGISTRAL = UR.UNIDAD_REGISTRAL
	 INNER JOIN #TMP_SOCIEDADES SOC ON CARTERA.SOCIEDAD = SOC.SOCIEDAD
    INNER JOIN @MOTIVO_SALIDA MOTIVO ON CARTERA.CODIGO_ACTUACION_BAJA = MOTIVO.CODIGO_ACTUACION_BAJA_UR
	WHERE CARTERA.PERIODO = @ANYOMES
	AND UR.IND_MIGRACION = 'X'
      
      
    /* USR057_CLASIFICACION_EXISTENCIAS */
    
    UPDATE CARTERA
    SET USR057_CLASIFICACION_EXISTENCIAS = CASE WHEN ISNULL(ADJ450_ESTADO_CONSTRUCCION, '0') = '0' THEN '1'
		                                        WHEN ADJ450_ESTADO_CONSTRUCCION IN('2', '3') THEN '2'
		                                        WHEN ADJ450_ESTADO_CONSTRUCCION = '1' THEN '3'
		                                        ELSE '' END
    FROM [JUNO].[MAESTRO_CARTERA] CARTERA
    INNER JOIN [JUNO].[TMP_UR_MAESTRO_HIST] UR ON CARTERA.SOCIEDAD = UR.SOCIEDAD AND CARTERA.UNIDAD_REGISTRAL = UR.UNIDAD_REGISTRAL
	 INNER JOIN #TMP_SOCIEDADES SOC ON CARTERA.SOCIEDAD = SOC.SOCIEDAD
   WHERE CARTERA.PERIODO = @ANYOMES
	AND UR.IND_MIGRACION = 'X'


	/*
	|| Autor: Dani BietO
	|| Fecha: 2022.06.28
	|| Proceso: Se crea tabla temporal de Datos de Venta para informa los datos del comprador
	*/    
    
    DROP TABLE IF EXISTS #TMP_JUNO_COMPRADORES_VENTA
    
    SELECT DISTINCT CARTERA.SOCIEDAD,
       CARTERA.UNIDAD_REGISTRAL,
	   VENTA.DOC_VENTA,
	   POS.ID_PEDIDO,
	   CLI.NIF,
	   CLI.NOMBRE_1,
	   CASE WHEN ISNULL(GRUPO.NIF,'')<>'' THEN 'SI'
	        ELSE 'NO'
	   END AS CONS20_COMPRADOR_SOCIEDAD_GRUPO
       INTO #TMP_JUNO_COMPRADORES_VENTA
  FROM [JUNO].[MAESTRO_CARTERA] CARTERA
  INNER JOIN [JUNO].[TMP_UR_MAESTRO_HIST] UR ON CARTERA.SOCIEDAD = UR.SOCIEDAD AND CARTERA.UNIDAD_REGISTRAL = UR.UNIDAD_REGISTRAL
  INNER JOIN #TMP_SOCIEDADES SOC ON CARTERA.SOCIEDAD = SOC.SOCIEDAD
  LEFT JOIN (SELECT SOCIEDAD, UNIDAD_REGISTRAL, FECHA_ANULACION, DOC_VENTA FROM [SVH_CORP_DB].[DBO].[VENTAS_OPERATIVA] WHERE ISNULL(FECHA_ANULACION,'')= '') VENTA
   ON CARTERA.SOCIEDAD = VENTA.SOCIEDAD
   AND CARTERA.UNIDAD_REGISTRAL = VENTA.UNIDAD_REGISTRAL
  LEFT JOIN [SVH_CORP_DB].[DBO].[PEDIDOS_VENTA_POSICIONES] POS
   ON VENTA.SOCIEDAD = POS.SOCIEDAD
   AND VENTA.UNIDAD_REGISTRAL = POS.UNIDAD_REGISTRAL
   AND VENTA.DOC_VENTA = POS.ID_PEDIDO
  LEFT JOIN SVH_CORP_DB.DBO.CLIENTES CLI
  ON POS.SOLICITANTE = CLI.NUM_DEUDOR
  LEFT JOIN (SELECT VALOR AS NIF
			   FROM [JUNO].[TMP_PARAMETRICA]
			  WHERE CONCEPTO = 'CONS20_COMPRADOR_SOCIEDAD_GRUPO'
				AND FLAG = 1) GRUPO
	ON CLI.NIF = GRUPO.NIF
   WHERE CARTERA.CONTROL_CARTERA = 'VENTA'
	AND CARTERA.PERIODO = @ANYOMES
	AND UR.IND_MIGRACION = 'X'
     
     
   UPDATE CARTERA
   SET USR081_COMPRADOR = VENTA.NOMBRE_1,
       USR092_COMPRADOR_NIF = VENTA.NIF,
       CONS20_COMPRADOR_SOCIEDAD_GRUPO = VENTA.CONS20_COMPRADOR_SOCIEDAD_GRUPO
   FROM [JUNO].[MAESTRO_CARTERA] CARTERA
   INNER JOIN #TMP_SOCIEDADES SOC ON CARTERA.SOCIEDAD = SOC.SOCIEDAD
   INNER JOIN #TMP_JUNO_COMPRADORES_VENTA VENTA ON CARTERA.SOCIEDAD = VENTA.SOCIEDAD AND CARTERA.UNIDAD_REGISTRAL = VENTA.UNIDAD_REGISTRAL
   WHERE CARTERA.CONTROL_CARTERA = 'VENTA'
   AND CARTERA.PERIODO = @ANYOMES      
      
/* ======================================================== 
        UPDATE ESPECIFICO PARA INMUEBLES USR059
    ======================================================== */
    
   
   UPDATE CARTERA
   SET USR059_INCREMENTO_VALOR_CONSOLIDADO = ADJ007_VALOR_CONTABLE_BRUTO - USR058_VALOR_ADQUISICION_CONSOLIDADO - USR076_COMPENSACION_PROTOCOLO_KB
   FROM  [JUNO].[MAESTRO_CARTERA] CARTERA
   INNER JOIN [JUNO].[TMP_UR_MAESTRO_HIST] UR ON CARTERA.SOCIEDAD = UR.SOCIEDAD AND CARTERA.UNIDAD_REGISTRAL = UR.UNIDAD_REGISTRAL
	INNER JOIN #TMP_SOCIEDADES SOC ON CARTERA.SOCIEDAD = SOC.SOCIEDAD    
	WHERE CARTERA.PERIODO = @ANYOMES
	AND UR.IND_MIGRACION = 'X'
	
    
   /* ======================================================== 
        UPDATE ESPECIFICO PARA INMUEBLES USR066
    ======================================================== */
    
       
   UPDATE CARTERA
   SET USR066_COSTE_BRUTO_CONSOLIDADO = USR058_VALOR_ADQUISICION_CONSOLIDADO + USR059_INCREMENTO_VALOR_CONSOLIDADO - USR043_AMORTIZACION +  USR017_IMPORTE_MENOR_COSTE_INICIAL + USR065_OTROS_AJUSTES_COSTE 
   FROM  [JUNO].[MAESTRO_CARTERA] CARTERA
   INNER JOIN [JUNO].[TMP_UR_MAESTRO_HIST] UR ON CARTERA.SOCIEDAD = UR.SOCIEDAD AND CARTERA.UNIDAD_REGISTRAL = UR.UNIDAD_REGISTRAL
	INNER JOIN #TMP_SOCIEDADES SOC ON CARTERA.SOCIEDAD = SOC.SOCIEDAD    
	WHERE CARTERA.PERIODO = @ANYOMES
	AND UR.IND_MIGRACION = 'X'
    
    
/* ==============================================================
    UPDATE ESPECIFICO PARA INMUEBLES CONS19
=================================================================*/

   UPDATE CARTERA
   SET CONS19_RESULTADO_VENTA_CONSOLIDADO = CARTERA.USR066_COSTE_BRUTO_CONSOLIDADO 
   FROM  [JUNO].[MAESTRO_CARTERA] CARTERA
   INNER JOIN [JUNO].[TMP_UR_MAESTRO_HIST] UR ON CARTERA.SOCIEDAD = UR.SOCIEDAD AND CARTERA.UNIDAD_REGISTRAL = UR.UNIDAD_REGISTRAL
	INNER JOIN #TMP_SOCIEDADES SOC ON CARTERA.SOCIEDAD = SOC.SOCIEDAD    
	WHERE CARTERA.PERIODO = @ANYOMES
	AND UR.IND_MIGRACION = 'X'
    
/* ==============================================================
    UPDATE ESPECIFICO PARA INMUEBLES CONS11
=================================================================*/


   UPDATE CARTERA
   SET CONS11_CORRECCION_CONSOLIDADA_PREVIA = CASE WHEN CARTERA.USR066_COSTE_BRUTO_CONSOLIDADO < CARTERA.CONS8_VALOR_MERCADO_CORREGIDO THEN 0.0 
                                                   ELSE CARTERA.CONS8_VALOR_MERCADO_CORREGIDO  - CARTERA.USR066_COSTE_BRUTO_CONSOLIDADO END
   FROM  [JUNO].[MAESTRO_CARTERA] CARTERA
   INNER JOIN [JUNO].[TMP_UR_MAESTRO_HIST] UR ON CARTERA.SOCIEDAD = UR.SOCIEDAD AND CARTERA.UNIDAD_REGISTRAL = UR.UNIDAD_REGISTRAL
	INNER JOIN #TMP_SOCIEDADES SOC ON CARTERA.SOCIEDAD = SOC.SOCIEDAD    
	WHERE CARTERA.PERIODO = @ANYOMES
	AND UR.IND_MIGRACION = 'X'
    
    
/* ==============================================================
                UPDATE ESPECIFICO PARA INMUEBLES CONS12
=================================================================*/

 
 
   UPDATE CARTERA
   SET CONS12_DOTACION_RECUPERACION_INICIAL = CARTERA.CONS11_CORRECCION_CONSOLIDADA_PREVIA - CARTERA.USR063_CORRECCION_CONSOLIDADA_CIERRE_EJERCICIO_ANTERIOR
   FROM  [JUNO].[MAESTRO_CARTERA] CARTERA
   INNER JOIN [JUNO].[TMP_UR_MAESTRO_HIST] UR ON CARTERA.SOCIEDAD = UR.SOCIEDAD AND CARTERA.UNIDAD_REGISTRAL = UR.UNIDAD_REGISTRAL
	INNER JOIN #TMP_SOCIEDADES SOC ON CARTERA.SOCIEDAD = SOC.SOCIEDAD    
	WHERE CARTERA.PERIODO = @ANYOMES
	AND UR.IND_MIGRACION = 'X'
    
/* ==============================================================
                UPDATE ESPECIFICO PARA INMUEBLES DOTACION RECUPERACION FINAL Y CONS13
=================================================================*/    
    
       

   UPDATE CARTERA
   SET DOTACION_RECUPERACION_FINAL = CASE    WHEN CARTERA.CONS12_DOTACION_RECUPERACION_INICIAL < 0              THEN CARTERA.CONS12_DOTACION_RECUPERACION_INICIAL
			                                 WHEN ISNULL(CARTERA.USR039_CLASIFICACION_CIRCULAR_4_2016, '') = '' THEN CARTERA.CONS12_DOTACION_RECUPERACION_INICIAL
			                                 WHEN CARTERA.ANTIGUEDAD > 3.00 THEN 0.00
			                                 ELSE CARTERA.CONS12_DOTACION_RECUPERACION_INICIAL
	                                END 
   FROM  [JUNO].[MAESTRO_CARTERA] CARTERA
   INNER JOIN [JUNO].[TMP_UR_MAESTRO_HIST] UR ON CARTERA.SOCIEDAD = UR.SOCIEDAD AND CARTERA.UNIDAD_REGISTRAL = UR.UNIDAD_REGISTRAL
	INNER JOIN #TMP_SOCIEDADES SOC ON CARTERA.SOCIEDAD = SOC.SOCIEDAD    
	WHERE CARTERA.PERIODO = @ANYOMES
	AND UR.IND_MIGRACION = 'X'

    UPDATE CARTERA
   SET CONS13_DOTACION_RECUPERACION_FINAL_ANTIGUEDAD = CASE WHEN CARTERA.DOTACION_RECUPERACION_FINAL < 0                         THEN CARTERA.DOTACION_RECUPERACION_FINAL
                                                            WHEN ISNULL(CARTERA.USR039_CLASIFICACION_CIRCULAR_4_2016, '') = ''   THEN CARTERA.DOTACION_RECUPERACION_FINAL
                                                            WHEN ISNULL(CARTERA.CONS17_FECHA_DISPOSICION,'') = ''                THEN CARTERA.DOTACION_RECUPERACION_FINAL
                                                            WHEN CARTERA.CONS17_FECHA_DISPOSICION > YEAR(GETDATE())              THEN CARTERA.DOTACION_RECUPERACION_FINAL
                                                            ELSE 0 
                                                       END 
   FROM  [JUNO].[MAESTRO_CARTERA] CARTERA
   INNER JOIN [JUNO].[TMP_UR_MAESTRO_HIST] UR ON CARTERA.SOCIEDAD = UR.SOCIEDAD AND CARTERA.UNIDAD_REGISTRAL = UR.UNIDAD_REGISTRAL
	INNER JOIN #TMP_SOCIEDADES SOC ON CARTERA.SOCIEDAD = SOC.SOCIEDAD    
	WHERE CARTERA.PERIODO = @ANYOMES
	AND UR.IND_MIGRACION = 'X'	 
     
 /* ==============================================================
                UPDATE ESPECIFICO PARA INMUEBLES CONS14
=================================================================*/
    
     

   UPDATE CARTERA
   SET CONS14_CORRECCION_CONSOLIDADO = CARTERA.USR063_CORRECCION_CONSOLIDADA_CIERRE_EJERCICIO_ANTERIOR + CARTERA.CONS13_DOTACION_RECUPERACION_FINAL_ANTIGUEDAD 
   FROM  [JUNO].[MAESTRO_CARTERA] CARTERA
   INNER JOIN [JUNO].[TMP_UR_MAESTRO_HIST] UR ON CARTERA.SOCIEDAD = UR.SOCIEDAD AND CARTERA.UNIDAD_REGISTRAL = UR.UNIDAD_REGISTRAL
	INNER JOIN #TMP_SOCIEDADES SOC ON CARTERA.SOCIEDAD = SOC.SOCIEDAD    
	WHERE CARTERA.PERIODO = @ANYOMES
	AND UR.IND_MIGRACION = 'X'	 
    
/* =================================================================
                UPDATE ESPECIFICO INMUEBLES ADJ332 Y CONTADORES  
====================================================================*/

   UPDATE CARTERA
   SET NUMERO_URS_STOCK_POR_PROMO_COMERCIAL = CASE WHEN CARTERA.CONTROL_CARTERA = 'STOCK' AND CARTERA.PROMOCION_COMERCIAL IS NOT NULL THEN COUNT(1) OVER(PARTITION BY CARTERA.SOCIEDAD, CARTERA.PROMOCION_COMERCIAL, CARTERA.CONTROL_CARTERA) ELSE 0 END,
       NUMERO_URS_VENTA_POR_PROMO_COMERCIAL = CASE WHEN CARTERA.CONTROL_CARTERA = 'VENTA' AND CARTERA.PROMOCION_COMERCIAL IS NOT NULL THEN COUNT(1) OVER(PARTITION BY CARTERA.SOCIEDAD, CARTERA.PROMOCION_COMERCIAL, CARTERA.CONTROL_CARTERA) ELSE 0 END,
       NUMERO_URS_BAJA_POR_PROMO_COMERCIAL  = CASE WHEN CARTERA.CONTROL_CARTERA = 'BAJA'  AND CARTERA.PROMOCION_COMERCIAL IS NOT NULL THEN COUNT(1) OVER(PARTITION BY CARTERA.SOCIEDAD, CARTERA.PROMOCION_COMERCIAL, CARTERA.CONTROL_CARTERA) ELSE 0 END,
       TOTAL_URS_POR_PROMO_COMERCIAL =        CASE WHEN CARTERA.PROMOCION_COMERCIAL IS NOT NULL THEN COUNT(1) OVER(PARTITION BY CARTERA.SOCIEDAD, CARTERA.PROMOCION_COMERCIAL) END
   FROM  [JUNO].[MAESTRO_CARTERA] CARTERA
   INNER JOIN [JUNO].[TMP_UR_MAESTRO_HIST] UR ON CARTERA.SOCIEDAD = UR.SOCIEDAD AND CARTERA.UNIDAD_REGISTRAL = UR.UNIDAD_REGISTRAL
	INNER JOIN #TMP_SOCIEDADES SOC ON CARTERA.SOCIEDAD = SOC.SOCIEDAD    
	WHERE CARTERA.PERIODO = @ANYOMES
	AND UR.IND_MIGRACION = 'X'
    
    

   UPDATE CARTERA
   SET ADJ332_PORCENTAJE_VENTAS_FORMALIZADAS = CAST(CAST(CARTERA.NUMERO_URS_VENTA_POR_PROMO_COMERCIAL AS NUMERIC(6,2))/CAST(CARTERA.TOTAL_URS_POR_PROMO_COMERCIAL AS NUMERIC(6, 2)) * 100 AS NUMERIC(6,2)) 
   FROM  [JUNO].[MAESTRO_CARTERA] CARTERA
   INNER JOIN [JUNO].[TMP_UR_MAESTRO_HIST] UR ON CARTERA.SOCIEDAD = UR.SOCIEDAD AND CARTERA.UNIDAD_REGISTRAL = UR.UNIDAD_REGISTRAL
	INNER JOIN #TMP_SOCIEDADES SOC ON CARTERA.SOCIEDAD = SOC.SOCIEDAD    
	WHERE CARTERA.PERIODO = @ANYOMES
	AND UR.IND_MIGRACION = 'X'    
         
--=========================================================================================================================================
--										Temporal UR_CLASIFICACION_BDE para informar campos USR006 y USR007 
--=========================================================================================================================================

DROP TABLE IF EXISTS #TMP_CLASIFICACIONES_BDE

SELECT UR.SOCIEDAD, 
       UR.UNIDAD_REGISTRAL, 
       BDE.CODIGO_BDE_C6C7, 
       BDE.CRITERIO_5_INFORME_C6_C7, 
       PARAM_USR006.VALOR AS USR006_CLASIFICACION_ACTIVO,       
       PARAM_USR007.VALOR AS USR007_CLASIFICACION_T18 
       INTO #TMP_CLASIFICACIONES_BDE
FROM [SVH_CORP_DB].[DBO].[UR_CLASIFICACION_BDE] BDE
INNER JOIN [JUNO].[TMP_UR_MAESTRO_HIST] UR ON BDE.SOCIEDAD = UR.SOCIEDAD AND BDE.UNIDAD_REGISTRAL = UR.UNIDAD_REGISTRAL
LEFT JOIN  (SELECT CONCEPTO, CAMPO, VALOR 
              FROM [JUNO].[TMP_PARAMETRICA] 
             WHERE INFORME = 'USR007_CLASIFICACION_T18') PARAM_USR007
 ON BDE.CODIGO_BDE_C6C7          = PARAM_USR007.CONCEPTO
AND BDE.CRITERIO_5_INFORME_C6_C7 = PARAM_USR007.CAMPO
LEFT JOIN  (SELECT CONCEPTO, CAMPO, VALOR 
              FROM [JUNO].[TMP_PARAMETRICA] 
             WHERE INFORME = 'USR006_CLASIFICACION_ACTIVO') PARAM_USR006
 ON BDE.CODIGO_BDE_C6C7          = PARAM_USR006.CONCEPTO
AND BDE.CRITERIO_5_INFORME_C6_C7 = PARAM_USR006.CAMPO
WHERE UR.IND_MIGRACION = 'X'


    
   /* ======================================================== 
        UPDATE ESPECIFICO PARA INMUEBLES USR006 Y USR007
    ======================================================== */
    
       
   UPDATE CARTERA
   SET USR006_CLASIFICACION_ACTIVO = BDE.USR006_CLASIFICACION_ACTIVO,
       USR007_CLASIFICACION_T18    = BDE.USR007_CLASIFICACION_T18
   FROM  [JUNO].[MAESTRO_CARTERA] CARTERA
   INNER JOIN [JUNO].[TMP_UR_MAESTRO_HIST] UR ON CARTERA.SOCIEDAD = UR.SOCIEDAD  AND CARTERA.UNIDAD_REGISTRAL = UR.UNIDAD_REGISTRAL
   INNER JOIN #TMP_SOCIEDADES SOC             ON CARTERA.SOCIEDAD = SOC.SOCIEDAD  
   INNER JOIN #TMP_CLASIFICACIONES_BDE BDE    ON CARTERA.SOCIEDAD = BDE.SOCIEDAD AND CARTERA.UNIDAD_REGISTRAL = BDE.UNIDAD_REGISTRAL
   WHERE CARTERA.PERIODO = @ANYOMES
   AND   UR.IND_MIGRACION = 'X'
   
   
   
   --=======================================================================================================================--
   --=======================================================================================================================--
   --                               UPDATES ESPECIFICOS DE ARRENDAMIENTOS                                                   --
   --=======================================================================================================================--
   --=======================================================================================================================--
   
DROP TABLE IF EXISTS #TMP_RENTA_CONTRATOS

SELECT CONT.SOCIEDAD,
       CONTRATO,
       SUM(IMPORTE_BRUTO_MES*12) AS IMPORTE_BRUTO_ANUAL,
		 SUM(IMPORTE_NETO_MES) IMPORTE_NETO_MES
INTO #TMP_RENTA_CONTRATOS       
FROM  SVH_CORP_DB.DBO.RENTA_CONTRATOS CONT
INNER JOIN #TMP_SOCIEDADES SOC
  ON  CONT.SOCIEDAD = SOC.SOCIEDAD
WHERE CLASE_CONDICION IN ('100', '101', '103', '126','251', '252', '255') 
AND @FECHA_CIERRE_CONTABLE BETWEEN FECHA_INI_VALIDEZ_CONDICION AND FECHA_FIN_VALIDEZ_CONDICION
AND DIA = @FECHA_CIERRE_CONTABLE
GROUP BY CONT.SOCIEDAD, CONTRATO



UPDATE MAESTRO_UA
SET ADJ465_IMPORTE_BRUTO_ANUAL = RC.IMPORTE_BRUTO_ANUAL
  FROM JUNO.MAESTRO_UA_CONTRATOS MAESTRO_UA 
  INNER JOIN #TMP_RENTA_CONTRATOS RC 
     ON MAESTRO_UA.SOCIEDAD = RC.SOCIEDAD  
    AND MAESTRO_UA.CONTRATO = RC.CONTRATO
  WHERE MAESTRO_UA.PERIODO  = @ANYOMES